<!--
 Copyright (c) 2023 by frostime (Yp Z), All Rights Reserved.
 Author       : Yp Z
 Date         : 2023-07-02 16:25:24
 FilePath     : /src/lib/Bookmark/section.svelte
 LastEditTime : 2023-07-08 15:18:31
 Description  : Component of a expandable list section in bookmark dock
-->
<script lang="ts">
    // import { openBlock } from "@/func";
    // import { plugin, i18n } from "@/utils";
    import type { BlockId, IBookmarkItem } from "$lib/types";

    export let sectionTitle: string = "";
    export let items: IBookmarkItem[] = [];
    export let isExpanded: boolean = false;

    let liElement: HTMLElement;

    let liSvgClass = "b3-list-item__arrow";
    let ulClass = "fn__none";
    let titleStyle = "";
    $: {
        if (isExpanded) {
            liSvgClass = "b3-list-item__arrow b3-list-item__arrow--open";
            ulClass = "";
        } else {
            liSvgClass = "b3-list-item__arrow";
            ulClass = "fn__none";
        }
    }

    export function toggleExpand(expand?: boolean) {
        isExpanded = expand === undefined ? !isExpanded : expand;
    }


    async function clickItem(docId: BlockId) {
        console.log("clickItem", docId); //
        // let block: Block = await api.getBlockByID(id);
        if (docId) {
            // openBlock(docId);
        }
    }

    function clickCounter(event: MouseEvent) {
        event.stopPropagation();

    }
</script>

<li
    class="b3-list-item b3-list-item--hide-action"
    data-treetype="bookmark"
    data-type="undefined"
    data-subtype="undefined"
    bind:this={liElement}
    on:click={() => toggleExpand()}
    on:keydown={() => {}}
>
    <span
        style="padding-left: 4px;margin-right: 2px"
        class="b3-list-item__toggle b3-list-item__toggle--hl"
    >
        <svg data-id="Doing0" class={liSvgClass}
            ><use xlink:href="#iconRight" /></svg
        >
    </span>
    <svg class="b3-list-item__graphic"><use xlink:href="#iconBookmark" /></svg>
    <span class="b3-list-item__text" style={titleStyle}>{sectionTitle}</span>
    <!-- <span
        class="b3-list-item__action b3-tooltips b3-tooltips__w"
        aria-label={i18n.DockReserve.PopupResv}
        on:click={(event) => clickListMore(event)}
        on:keydown={() => {}}
    >
        <svg><use xlink:href="#iconMore" /></svg>
    </span> -->
    <span
        class="counter b3-list-item__action b3-tooltips b3-tooltips__w"
        aria-label=""
        on:click={(event) => clickCounter(event)}
        on:keydown={() => {}}
    >
        {items?.length}
    </span>
</li>

<ul class={ulClass}>
    {#each items as block}
        <li
            on:click={() => clickItem(block.id)}
            on:keydown={() => {}}
            class="b3-list-item b3-list-item--hide-action"
            data-node-id={block.id}
            data-ref-text=""
            data-def-id=""
            data-treetype="bookmark"
            data-def-path=""
        >
            <span
                style="padding-left: 22px;margin-right: 2px"
                class="b3-list-item__toggle fn__hidden"
            >
                <svg
                    data-id=""
                    class="b3-list-item__arrow"
                    ><use xlink:href="#iconRight" /></svg
                >
            </span>
            <span class="b3-list-item__text">{block.content}</span>

            <!-- <span class="b3-list-item__action"
                ><svg><use xlink:href="#iconMore" /></svg></span
            > -->
        </li>
    {/each}
</ul>